micro_utils.dokka
0.15.1

# WriteMapCRUDRepo

abstract class WriteMapCRUDRepo<ObjectType, IdType, InputValueType>(map: MutableMap<IdType, ObjectType> = mutableMapOf()) : WriteCRUDRepo<ObjectType, IdType, InputValueType>

## Constructors

WriteMapCRUDRepo
Link copied to clipboard
fun <ObjectType, IdType> WriteMapCRUDRepo(map: MutableMap<IdType, ObjectType> = mutableMapOf())

## Functions

create
Link copied to clipboard
open suspend override fun create(values: List<InputValueType>): List<ObjectType>
deleteById
Link copied to clipboard
open suspend override fun deleteById(ids: List<IdType>)
update
Link copied to clipboard
open suspend override fun update(values: List<UpdatedValuePair<IdType, InputValueType>>): List<ObjectType>
open suspend override fun update(id: IdType, value: InputValueType): ObjectType?

## Properties

deletedObjectsIdsFlow
Link copied to clipboard
open override val deletedObjectsIdsFlow: Flow<IdType>
newObjectsFlow
Link copied to clipboard
open override val newObjectsFlow: Flow<ObjectType>
updatedObjectsFlow
Link copied to clipboard
open override val updatedObjectsFlow: Flow<ObjectType>

## Inheritors

MapCRUDRepo
Link copied to clipboard

## Extensions

caching
Link copied to clipboard
fun <ObjectType, IdType, InputType> WriteCRUDRepo<ObjectType, IdType, InputType>.caching(kvCache: KVCache<IdType, ObjectType>, scope: CoroutineScope, idGetter: (ObjectType) -> IdType): WriteCRUDCacheRepo<ObjectType, IdType, InputType>
create
Link copied to clipboard
suspend fun <ObjectType, IdType, InputValueType> WriteCRUDRepo<ObjectType, IdType, InputValueType>.create(vararg values: InputValueType): List<ObjectType>
deleteById
Link copied to clipboard
suspend fun <ObjectType, IdType, InputValueType> WriteCRUDRepo<ObjectType, IdType, InputValueType>.deleteById(vararg ids: IdType)
update
Link copied to clipboard
suspend fun <ObjectType, IdType, InputValueType> WriteCRUDRepo<ObjectType, IdType, InputValueType>.update(vararg values: UpdatedValuePair<IdType, InputValueType>): List<ObjectType>
withMapper
Link copied to clipboard
inline fun <FromKey, FromValue, FromInput, ToKey, ToValue, ToInput> WriteCRUDRepo<ToValue, ToKey, ToInput>.withMapper(mapper: MapperRepo<FromKey, FromValue, ToKey, ToValue>, simpleSuspendableMapper: SimpleSuspendableMapper<FromInput, ToInput>): WriteCRUDRepo<FromValue, FromKey, FromInput>
inline fun <FromKey, FromValue, FromInput, ToKey, ToValue, ToInput> WriteCRUDRepo<ToValue, ToKey, ToInput>.withMapper(noinline keyFromToTo: suspend FromKey.() -> ToKey = { this as ToKey }, noinline valueFromToTo: suspend FromValue.() -> ToValue = { this as ToValue }, noinline inputFromToTo: suspend FromInput.() -> ToInput = { this as ToInput }, noinline keyToToFrom: suspend ToKey.() -> FromKey = { this as FromKey }, noinline valueToToFrom: suspend ToValue.() -> FromValue = { this as FromValue }, noinline inputToToFrom: suspend ToInput.() -> FromInput = { this as FromInput }): WriteCRUDRepo<FromValue, FromKey, FromInput>